#version 120
#extension GL_ARB_shader_texture_lod : enable

/*
Before modify anything, read the agreement first that can be found here : https://werrusshaders.wordpress.com/download/
Werrus shaders, derived from Chocapic13 V5.
This code is from Chocapic13' shaders.
*/

const bool gaux2MipmapEnabled = true;

varying vec4 texcoord;

uniform sampler2D gaux2;
uniform float aspectRatio;
uniform float viewWidth;
uniform float viewHeight;
uniform int fogMode;
float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;

//////////////////////////////VOID MAIN//////////////////////////////

void main() {
//Bloom
const float rMult = 0.0016;
const int nSteps = 15;


int center = (nSteps-1)/2;
float radius = center*rMult;

vec3 blur = vec3(0.0);
float tw = 0.0;

float sigma = 0.3;


for (int i = 0; i < nSteps; i++) {

float dist = (i-float(center))/center;

float weight = exp(-(dist*dist)/(2.0*sigma));

blur += pow(texture2DLod(gaux2,texcoord.xy + rMult*vec2(1.0,aspectRatio)*vec2(i-center,0.0),2).rgb,vec3(2.2))*weight;

tw += weight;
}
blur /= tw;
blur = clamp(pow(blur,vec3(1.0/2.2)),0.0,1.0);
/* DRAWBUFFERS:3 */
	gl_FragData[0] = vec4(blur,1.0);
}
