#version 120

/*
Before modify anything, read the agreement first that can be found here : https://werrusshaders.wordpress.com/download/
Werrus shaders, derived from Chocapic13 V5.
This code is from Chocapic13' shaders.
*/

/* DRAWBUFFERS:024 */

//////////////////////////////ADJUSTABLE VARIABLES//////////////////////////////

	vec4 watercolor = vec4(0.0,0.13,0.2,0.4); 	//water color and opacity (r,g,b,opacity)

//////////////////////////////END OF ADJUSTABLE VARIABLES///////////////////////

const int MAX_OCCLUSION_POINTS = 20;
const float MAX_OCCLUSION_DISTANCE = 100.0;
const float bump_distance = 64.0;				//Bump render distance: tiny = 32, short = 64, normal = 128, far = 256
const float pom_distance = 32.0;				//POM render distance: tiny = 32, short = 64, normal = 128, far = 256
const float fademult = 0.1;
const float PI = 3.1415927;

varying vec4 color;
varying vec4 texcoord;
varying vec4 lmcoord;
varying vec4 position;
varying vec3 binormal;
varying vec3 normal;
varying vec3 tangent;
varying vec3 viewVector;
varying vec3 wpos;
varying float iswater;

uniform sampler2D texture;
uniform sampler2D noisetex;
uniform int worldTime;
uniform float far;
uniform float rainStrength;
uniform float frameTimeCounter;

float timefract = worldTime;

float rainx = clamp(rainStrength, 0.0f, 1.0f)/1.0f;

vec2 dx = dFdx(texcoord.xy);
vec2 dy = dFdy(texcoord.xy);

float wave(float n) {
return sin(2 * PI * (n));
}

float waterH(vec2 posxz) {

vec2 movement = vec2(frameTimeCounter/2000,frameTimeCounter/2000);
vec2 movement2 = vec2(-frameTimeCounter/2000,frameTimeCounter/2000);
vec2 movement3 = vec2(frameTimeCounter/2000,-frameTimeCounter/2000);
vec2 movement4 = vec2(-frameTimeCounter/2000,-frameTimeCounter/2000);

vec2 coord = (posxz/760.0)+(movement);
vec2 coord1 = (posxz/759.9)+(movement2);
vec2 coord2 = (posxz/759.8)+(movement3);
vec2 coord3 = (posxz/759.7)+(movement4);
vec2 coord4 = (posxz/1460.0)+(movement);
vec2 coord5 = (posxz/1459.9)+(movement2);
vec2 coord6 = (posxz/1459.8)+(movement3);
vec2 coord7 = (posxz/1459.7)+(movement4);
vec2 coord8 = (posxz/2160.0)+(movement);
vec2 coord9 = (posxz/2159.9)+(movement2);
vec2 coord10 = (posxz/2159.8)+(movement3);
vec2 coord11 = (posxz/2159.7)+(movement4);
float noise = texture2D(noisetex,fract(coord.xy/2.0)).x;
noise += texture2D(noisetex,fract(coord.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord1.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord1.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord1.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord2.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord2.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord2.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord3.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord3.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord3.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord4.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord4.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord4.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord5.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord5.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord5.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord6.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord6.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord6.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord7.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord7.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord7.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord8.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord8.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord8.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord9.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord9.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord9.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord10.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord10.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord10.xy*4.0)).x/8.0;
noise += texture2D(noisetex,fract(coord11.xy)).x/2.0;
noise += texture2D(noisetex,fract(coord11.xy*2.0)).x/4.0;
noise += texture2D(noisetex,fract(coord11.xy*4.0)).x/8.0;

return noise;
}

float waterH2(vec3 posxz) {

float wave = 0.0;


float factor = 1.0;
float amplitude = 0.3;
float speed = 3.5;
float size = 0.2;
	
float px = posxz.x/50.0 + 250.0;
float py = posxz.z/50.0  + 250.0;

float fpx = abs(fract(px*20.0)-0.5)*2.0;
float fpy = abs(fract(py*20.0)-0.5)*2.0;

float d = length(vec2(fpx,fpy));

for (int i = 1; i < 5; i++) {
wave -= d*factor*cos( (1/factor)*px*py*size + 1.0*frameTimeCounter*speed);
factor /= 2;
}

factor = 1.0;
px = -posxz.x/50.0 + 250.0;
py = -posxz.z/150.0 - 250.0;

fpx = abs(fract(px*20.0)-0.5)*2.0;
fpy = abs(fract(py*20.0)-0.5)*2.0;

d = length(vec2(fpx,fpy));
float wave2 = 0.0;
for (int i = 1; i < 5; i++) {
wave2 -= d*factor*cos( (1/factor)*px*py*size + 1.0*frameTimeCounter*speed);
factor /= 2;
}

return amplitude*wave2+amplitude*wave;
}

//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////

void main() {	
	
	vec4 tex = vec4((watercolor*length(texture2D(texture, texcoord.xy).rgb*color.rgb)*color).rgb,watercolor.a);
	if (iswater < 0.9)  tex = texture2D(texture, texcoord.xy)*color;

	vec3 posxz = wpos.xyz;
	posxz.x += sin(posxz.z+frameTimeCounter)*0.25;
	posxz.z += cos(posxz.x+frameTimeCounter*0.5)*0.25;

	float deltaPos = 0.1;
	float h0 = waterH(posxz.xz);
	float h1 = waterH(posxz.xz + vec2(deltaPos,0.0));
	float h2 = waterH(posxz.xz + vec2(-deltaPos,0.0));
	float h3 = waterH(posxz.xz + vec2(0.0,deltaPos));
	float h4 = waterH(posxz.xz + vec2(0.0,-deltaPos));
	
	float xDelta = (h1-h0)+(h0-h2);
	float yDelta = (h3-h0)+(h0-h4);
	
	vec3 newnormal = normalize(vec3(xDelta,yDelta,1.0-pow(abs(xDelta+yDelta),2.0)));

	posxz.x += sin(posxz.z+frameTimeCounter)*0.1;
	posxz.z += cos(posxz.x+frameTimeCounter*0.5)*0.1;
	
	float deltaPos2 = 0.4;
	float h02 = waterH2(posxz);
	float h12 = waterH2(posxz + vec3(deltaPos2,0.0,0.0));
	float h22 = waterH2(posxz + vec3(-deltaPos2,0.0,0.0));
	float h32 = waterH2(posxz + vec3(0.0,0.0,deltaPos2));
	float h42 = waterH2(posxz + vec3(0.0,0.0,-deltaPos2));
	
	float xDelta2 = ((h12-h02)+(h02-h22))/deltaPos2;
	float yDelta2 = ((h32-h02)+(h02-h42))/deltaPos2;
	
	vec3 newnormal2 = normalize(vec3(xDelta2,yDelta2,1.0-xDelta2*xDelta2-yDelta2*yDelta2));

	vec4 frag2;
		frag2 = vec4((normal) * 0.5f + 0.5f, 1.0f);			
	float NdotE = sqrt(abs(dot(normal,normalize(position.xyz))));
	if (iswater > 0.9) {
		vec3 bump = newnormal+newnormal2*0.35;
			bump = bump;
			
		
		float bumpmult = 0.1*NdotE;	
		
		bump = bump * vec3(bumpmult, bumpmult, bumpmult) + vec3(0.0f, 0.0f, 1.0f - bumpmult);
		mat3 tbnMatrix = mat3(tangent.x, binormal.x, normal.x,
							tangent.y, binormal.y, normal.y,
							tangent.z, binormal.z, normal.z);
		
		frag2 = vec4(normalize(bump * tbnMatrix) * 0.5 + 0.5, 1.0);
	}
	
	gl_FragData[0] = tex;
	
	gl_FragData[1] = frag2;	
	
	gl_FragData[2] = vec4(lmcoord.t, mix(1.0,0.05,iswater), lmcoord.s, 1.0);
}